//
//  SailassistApp.swift
//  Sailassist
//
//  Created by Mamoru Sugita on 2023/10/13.
//

import SwiftUI
import UserNotifications
import WindowsAzureMessaging

@main
struct SailassistApp: App {
    @UIApplicationDelegateAdaptor(AppDelegate.self) private var appDelegate
    @State private var isTermsAgree = Preferences.termsAgreeDate != nil
    @State private var isPrivAgree = Preferences.privacyPolicyAgreeDate != nil

    let locationViewModel = LocationViewModel()
    let signalRService = SignalRService()
    var body: some Scene {
        WindowGroup {
            if !isTermsAgree{
                VStack(spacing: 0){
                    if let htmlPath = Bundle.main.path(forResource: "terms", ofType: "html") {
                        WebView(isLoading: .constant(false), url: htmlPath)
                    }

                    YesNoButtons(yesTitle: "Accept", noTitle: "Cancel") {
                        Preferences.termsAgreeDate_Int64 = DateTextLib.Date2UnixTime(date: Date())
                        isTermsAgree = true
                    } noAction: {
                        exit(0)
                    }
                }
                .preferredColorScheme(.dark)

            }else if !isPrivAgree{
                VStack(spacing: 0){
                    if let htmlPath = Bundle.main.path(forResource: "privacy", ofType: "html") {
                        WebView(isLoading: .constant(false), url: htmlPath)
                    }
                    
                    YesNoButtons(yesTitle: "Accept", noTitle: "Cancel") {
                        Preferences.privacyPolicyAgreeDate_Int64 = DateTextLib.Date2UnixTime(date: Date())
                        isPrivAgree = true
                    } noAction: {
                        exit(0)
                    }
                        
                }
                .preferredColorScheme(.dark)
            } else {
                ContentView()
                    .environmentObject(locationViewModel)
            }
        }
    }
}

class NotificationTags: NSObject {
    func addTags() {
        MSNotificationHub.clearTags()
        if Preferences.shipId != 0 {
            let shipId = String(Preferences.shipId)
            let routeTag = "route-" + shipId
            let bamTag = "bam-" + shipId
            let taskAlertTag = "taskalert-" + shipId
            let sailassistTag = "sailassist-" + shipId
            let emergencyTag = "emergency-" + shipId
//            let chatTag = "chat-" + shipId
            MSNotificationHub.addTags([routeTag, bamTag, taskAlertTag, sailassistTag, emergencyTag])
        }
    }
}

class AppDelegate: NSObject, UIApplicationDelegate ,MSNotificationHubDelegate, MSInstallationLifecycleDelegate {

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey : Any]? = nil) -> Bool {
        print(debug: "called")

        //プッシュ通知の利用許可のリクエスト送信
        UNUserNotificationCenter.current().requestAuthorization(options: [.alert, .sound, .badge]) { (granted, error) in
            if error != nil {
                return
            }
            if granted {
                MSNotificationHub.setLifecycleDelegate(self)
                UNUserNotificationCenter.current().delegate = self
                MSNotificationHub.setDelegate(self)

                MSNotificationHub.start(connectionString: HttpRequestType.ConnectionString.rawValue, hubName: HttpRequestType.HubName.rawValue)
            }
        }
        DispatchQueue.main.async {
            application.registerForRemoteNotifications()
        }

        //ユニークな値の生成
        if Preferences.DeviceId == "" {
            Preferences.DeviceId = UUID().uuidString
        }

        return true
    }

    func application(_ application: UIApplication, configurationForConnecting connectingSceneSession: UISceneSession, options: UIScene.ConnectionOptions) -> UISceneConfiguration {
        print(debug: "called")
        let config = UISceneConfiguration(name: nil, sessionRole: connectingSceneSession.role)
        config.delegateClass = SceneDelegate.self
        return config
    }

    func application(_ application: UIApplication, didReceiveRemoteNotification userInfo: [AnyHashable : Any], fetchCompletionHandler completionHandler: @escaping (UIBackgroundFetchResult) -> Void) {
        print(debug: "called \(userInfo)")

        // Forward to MSNotificationHub
        MSNotificationHub.didReceiveRemoteNotification(userInfo)

        // Complete handling the notificationposition
        completionHandler(.noData)
    }

    // Push通知を受信した時（サイレントプッシュ）
    func notificationHub(_ notificationHub: MSNotificationHub, didReceivePushNotification notification: MSNotificationHubMessage) {
//        let title = notification.title ?? ""
//        let body = notification.body ?? ""
        let userInfo = notification.userInfo
        print(debug: "called \(String(describing: userInfo))")

        if !userInfo!.isEmpty {
            let ecaList = GetEcaList()
            ecaList.start()
        }
    }

    // APNs 登録成功時に呼ばれる
    func application(_ application: UIApplication, didRegisterForRemoteNotificationsWithDeviceToken deviceToken: Data) {
        let token = deviceToken.map { String(format: "%.2hhx", $0) }.joined()
        print("デバイストークン : \(token)")
    }

    // APNs 登録失敗時に呼ばれる
    func application(_ application: UIApplication, didFailToRegisterForRemoteNotificationsWithError error: Error) {
        print("APNs 登録に失敗しました : \(error.localizedDescription)")
    }
}

extension AppDelegate: UNUserNotificationCenterDelegate {
    // フォアグラウンド状態で通知を受信して表示する
    func userNotificationCenter(_ center: UNUserNotificationCenter,
                              willPresent notification: UNNotification,
        withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void) {
        let userInfo = notification.request.content.userInfo
        if !userInfo.isEmpty {
            guard let arrAPS = userInfo["aps"] as? [String: Any] else {
                completionHandler([[.banner, .badge, .sound]])
                return
            }

            completionHandler([[.banner, .badge, .sound]])

            let arrCategory = arrAPS["category"] as? String ?? ""
            switch arrCategory {
//            case "chat":
//                guard let arrAlert = arrAPS["alert"] as? [String: Any] else {
//                    return
//                }
//                let subtitle = arrAlert["subtitle"] as? String ?? ""    //送信先名称
//                let strTitle = arrAlert["title"] as? String ?? ""       //送信内容
//                let strBody = arrAlert["body"] as? String ?? ""         //船名
//                let message = GetMessage()
//                message.start()
            case "sailassist":
                print(debug: "sailassist")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "bam":
                print(debug: "bam")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "route":
                print(debug: "route")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "emergency":
                print(debug: "emergency")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            default:
                print(debug: "default")
            }
        }
    }

    // バックグラウンド状態で通知を受信して表示する
    func userNotificationCenter(_ center: UNUserNotificationCenter,
                              didReceive response: UNNotificationResponse,
                              withCompletionHandler completionHandler: @escaping () -> Void) {
        let userInfo = response.notification.request.content.userInfo
        print(debug: userInfo)
        if !userInfo.isEmpty {
            guard let arrAPS = userInfo["aps"] as? [String: Any] else {
                completionHandler()
                return
            }

            completionHandler()

            let arrCategory = arrAPS["category"] as? String ?? ""
            switch arrCategory {
//            case "chat":
//                guard let arrAlert = arrAPS["alert"] as? [String: Any] else {
//                    return
//                }
//                let subtitle = arrAlert["subtitle"] as? String ?? ""    //送信先名称
//                let strTitle = arrAlert["title"] as? String ?? ""       //送信内容
//                let strBody = arrAlert["body"] as? String ?? ""         //船名
//                let message = GetMessage()
//                message.start()
            case "sailassist":
                print(debug: "sailassist")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "bam":
                print(debug: "bam")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "route":
                print(debug: "route")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            case "emergency":
                print(debug: "emergency")
                let getPushHistory = GetPushHistory()
                getPushHistory.start()
            default:
                print(debug: "default")
            }
        }
    }
}

class SceneDelegate: UIResponder, UIWindowSceneDelegate, ObservableObject {
    weak var windowScene: UIWindowScene?
    var tabWindow: UIWindow?
    
    func scene(_ scene: UIScene, willConnectTo session: UISceneSession, options connectionOptions: UIScene.ConnectionOptions) {
        windowScene = scene as? UIWindowScene
    }

    func addTabBar(_ selectedTabModel: SelectedTabModel){
        guard let scene = windowScene else{
            return
        }
        
        let tabBarController = UIHostingController(rootView:
            CustomTabBar()
                .environmentObject(selectedTabModel)
                .frame(maxHeight: .infinity, alignment: .bottom)
        )
        
        tabBarController.view.backgroundColor = .clear
        
        let tabWindow = PassThroughWindow(windowScene: scene)
        tabWindow.rootViewController = tabBarController
        tabWindow.isHidden = false
        
        self.tabWindow = tabWindow
    }
}


class PassThroughWindow: UIWindow{
    override func hitTest(_ point: CGPoint, with event: UIEvent?) -> UIView? {
        guard let view = super.hitTest(point, with: event) else { return nil}
        return rootViewController?.view == view ? nil : view
    }
}

// MARK: コメント出力を消す
func print(debug: Any = "", function: String = #function, file: String = #file, line: Int = #line) {
    #if DEBUG
        var filename: NSString = file as NSString
        filename = filename.lastPathComponent as NSString
        // Swift.print("File: \(filename), Line: \(line), Func: \(function) \n\(debug)")

        let outstr = String( format: "APPDebug File: %@, Line: %d, Func: %@\n\(debug)", filename, line, function )
        // Swift.print( outstr ) NSLog がある時は、両方に出るのでいらない
        NSLog( outstr )     // デバッグコンソールにも出力
    #endif
}
